// Make dc_goto notes from goto_stmt nodes.
// Create dc_arc_son nodes from them to their destination label_decls.

/* AJM 2001 Mar 29 */

#include <stdio.h>
#include <string.h>
#include <gd_graph.h>
#include "gd_utils.h"

int main (int argc, char *argv [])
{
    void do_gotos (gd_graph *);
    char *infilename;
    char *outfilename;
    int i;
    gd_graph g;		// the graph

    if (argc != 3)
    {
      fprintf (stderr, "usage: %s ingdfile outgdfile\n", argv [0]);
      exit (1);
    }

    infilename = argv[1];
    outfilename = argv[2];

    g = gd_graph_read_binary_file (infilename, 1.1, 1.0, 1.1);
    if (g. curStringPos == 0) {
	fprintf (stderr,"can't read gd graph on %s\n", infilename);
	exit (1);
    }

    do_gotos (&g);

    if (gd_graph_write_binary_file (outfilename, g) == 0)
    {
	fprintf (stderr, "can't write %s\n", outfilename);
	exit (1);
    }

    return 0;
}

void do_gotos (gd_graph *g)
{
    int i;
    gd_graph_node *p;			// Pointer to node which is to be converted to object.
    node_ptr ptr;			// Ptr to node which is to be converted to object.

    gd_graph_node new_node;		// New Datrix node for the goto statement
    gd_graph_node new_edge;		// New Datrix edge for the arcson edge

    // Do all the gotos.
    for (ptr = 0; ptr < g-> curNodePos; ++ ptr)
    {
	p = &(g-> nodeBuffer [ptr]);

	if (p-> common. type == gGOTO_STMT)
	{
	    // This is a gcc goto statement.

	    new_node. common. type = dC_GOTO;
	    new_node. common. other_node = p-> goto_stmt. next;	// save next pointer
	    new_node. dc_goto. dest = newNode (g);		// get new node for edge

	    new_edge. common. type = dC_ARC_SON;
	    new_edge. common. other_node = -1;
	    new_edge. dc_arc. ordinal = 0;
	    new_edge. dc_arc. src = ptr;			// from this goto
	    new_edge. dc_arc. dest = p-> goto_stmt. dest;	// to this label decl
	    new_edge. dc_arc. next = -1;

	    g-> nodeBuffer [ptr] = new_node;
	    g-> nodeBuffer [new_node. dc_goto. dest] = new_edge;
	}
    }
}
