/*+
 * Name:	zap_void.c
 *
 * Purpose:	Removes built in void type if not refernced by any nodes
 *
 * Author:	Thomas R. Dean
 *
 * Date:	April 10, 2001
 *
-*/

#include <stdio.h>
#include <stdlib.h>

#include "gd_graph.h"
#include "gd_utils.h"

char * progname;

void usage(){
  fprintf(stderr,"usage: %s infile outfile\n",progname);
  exit(1);
}

int main(int argc, char * argv[]){
  gd_graph g;
  char * filename, *outfilename;
  int nodenum,i, count;
  node_ptr *rover;
  str_ptr void_ptr;
  progname = argv[0];

  if (argc != 3) {
    usage();
  }

  filename = argv[1];
  outfilename = argv[2];

  g = gd_graph_read_binary_file(filename,1.0,1.0,1.0);
  if (g.curStringPos == 0) {
    fprintf(stderr,"could not get graph\n");
    exit(1);
  }

  /* start at front node */
  for(i = 0; i < g.curNodePos; i++){
    g.nodeBuffer[i].common.other_node = -1;
  }

  /* all done, write the file */
  if (gd_graph_write_binary_file(outfilename,g) == 0){
    fprintf(stderr,"problem writing file\n");
    exit(1);
  }


  return 0;
}

